﻿:Namespace SALTUtils
⍝ Utility Functions used by SALT
⍝ Version for V1.18, 2007/9/11 Ignore hidden & system files
⍝ Version for V1.17, 2007/9/05 Ext name change to SALT_Data, V11.1 compatibility
⍝ Version for V1.16, 2007/8/21 Bug fix for Spice accellerator
⍝ Version for V1.15, 2007/7/23 Changed external namespace name to ÛÁÐÝ_Data
⍝ Version for V1.14, 2007/7/13 Pfkey for Spice
⍝ Version for V1.13, 2007/6/15 Unix compatibility fixes
⍝ Version for V1.12, 2007/5/30 DirU fixed, <remExt> added
⍝ Version for V1.11, 2007/3/19 removed Tabs from source, added Collapse in <Forget>
⍝ Version for V1.10, 2007/3/16 allowed SourceFile not to be present
⍝ Version for V1.09, 2007/3/14 added DEBUG
⍝ Version for V1.08, 2007/3/08 minor bug fixes
⍝ Version for V1.04, 2007/2/14 Added Dir fns & ":Access Shared Private" statements all over
⍝ Version for V1.02, 2007/1/22 Fixed Spice bug + minor changes
⍝ Version for V1.01, 2007/1/16 Added ability to store registry keys
⍝ Version for V1.00, 2007/1/13 Modified comments, removed ⋄s, added 3 utilities
    
    ⎕io←1  ⋄  ⎕USING←0⍴⊂'' ⋄ ⎕ML←3 ⋄ DEBUG←0
    
    ∇ {r}←Spice msg;cmd;arg;list;i;c;find;names
⍝ Handle KeyPress in SPICE command window
⍝ The function can also be used directly with a string
      r←¯1
      :If ~isChar cmd←msg
          →0↓⍨'ER'≡3⊃msg ⍝ EnteR?
          cmd←rlb(1⊃msg)⎕WG'Text'
          (↑msg)⎕WS'Items'({(20⌊⍴⍵)↑⍵}(⊂cmd)∪(↑msg)⎕WG'Items')
      :EndIf
     
      :If '?'∊↑cmd ⋄ cmd←'? ',1↓cmd ⋄ :EndIf ⍝ accept ?cmd
      r←0
      (cmd arg)←cmd splitOn1st' '
      list←⎕SE.cbbot.bandsalt.Spice.List
      names←⎕SE.U.lcase¨list.Name
      find←{names strIndex⊂⎕SE.U.lcase ⍵}
      ⎕←'' ⋄ ⎕←'[S]: ',cmd,' ',arg
     
      :If isHelp cmd ⍝ Special case '?'
          i←⍳⍴list
          :If 0=⍴arg←⎕SE.U.lcase arg~' ' ⍝ One command
          :OrIf 0≠⍴i←{⍵/⍳⍴⍵}(⎕SE.U.lcase¨list.Group)∊⊂arg ⍝ Group Name
              c←(,[0.5]∘'='¨'Group' 'Name' 'Description')⍪{⍵[⍋⍕⍵[;1 2];]}⊃list[,i].(Group Name Desc)
              c[1+{⍵/⍳⍴⍵}2≡/c[;1];1]←⊂''
              ⎕←'? commandname           for more info' ⋄ ''
              ⎕←c
          :Else
              :If 0<i←find arg
                  ⎕←'Help for command: ',arg
                  :Trap DEBUG↓0
                      c←⎕SE.SALT.Load(list[↑i].FullName),' -noname'
                      ⎕←c.Help list[↑i].Name
                  :Else
                      ⎕←'Unable to produce Help for command:' ⋄ ⊃⎕DM
                  :EndTrap
              :Else
                  ⎕←'Unknown command: ',arg
              :EndIf
          :EndIf
      :Else
          :If 0<i←find cmd
              :Trap DEBUG↓0
                  c←⎕SE.SALT.Load(list[↑i].FullName),' -noname'
                  {~0∊⍴⍵:⎕←⍵}c.Run list[↑i].Name arg
              :Else
                  ⎕←'Command Execution Failed:' ⋄ ⊃⎕DM
              :EndTrap
          :Else
              ⎕←'Unknown command: ',cmd
          :EndIf
      :EndIf
    ∇
    
    ∇ BootSpice;t;z;ns;nc;folder;ev
⍝ Set up Spice
      '⎕se.cbbot.bandsalt'⎕WC'CoolBand'('Index' 1)
      t←⍬ ⋄ ev←'Event'('KeyPress' '⎕SE.SALTUtils.Spice')
      :If 11>z←1+(⎕PFKEY¨1+⍳9)⍳⊂''
          t←⊂('accelerator'(2↑111+z)) ⍝ when this PFkey is hit this event will happen
          ev,←⊂'select' '⍎2 ⎕nq ''⎕se.cbbot.bandsalt.Edit'' ''GotFocus'''
          '⎕PFKEY'z'will jump to the Spice command line'
      :EndIf
      t,←('FontObj'⎕SE.FontObj)ev('Attach' 'Top' 'Left' 'Top' 'Left')
      '⎕se.cbbot.bandsalt.Edit'⎕WC'Combo'('Style' 'DropEdit')('Size'(0 ¯150+⎕SE.cbbot.bandsb1.Size)),t
      ⎕SE.cbbot.bandsalt.Edit.Tip←'Spice Command Line - Type ? and hit Enter for a list of commands'
     
      ⎕SE.cbbot.bandsalt.Spice←⎕SE.⎕NS''
      ⎕SE.cbbot.bandsalt.Spice.List←⍬
     
      ⎕SE.SALT.Load'Dyalog\U -target=⎕SE'
      ⎕SE.SALT.Load'Dyalog\SALT\SpiceUtils -target=⎕SE'
      folder←({⍵,(FS≠¯1↑⍵)⍴FS}getEnvir'Dyalog'),'Classes',FS,'Spice',FS
      z←Dir folder,'*',SALTEXT
     
      :For t :In z
          :Trap 0
              ns←⎕SE.SALT.Load'Spice',FS,t,' -noname'
              nc←,ns.List
              ns←⎕SE.⎕NS¨(⍴nc)⍴⊂''
              ns.(Name Desc Parse Group)←nc.(Name Desc Parse Group)
              ns.FullName←⊂folder,t
              ⎕SE.cbbot.bandsalt.Spice.List,←ns
     
          :Else
              ⎕←'Error loading Spice Commands from ',t ⋄ ⊃⎕DM
          :EndTrap
      :EndFor
     
      ⎕←'Spice initialized - ',(⍕⍴⎕SE.cbbot.bandsalt.Spice.List),' commands available.'
    ∇
    
    ∇ Forget(folder name version keeplast);prev;t;v;f;cmd;list;last;new;old;s;dotVer;q;next;ok
⍝ Forget Backup Versions
      :Access Shared Private
      s←{(1=⍴⍺)↓'s',⍵}
      dotVer←{(0<⍵)/'.',⍕⍵}
      :If 12<⍴t←v←{⍵[⍋⍵]}version ⋄ t←t[1],(⊂'...'),¯1↑t ⋄ :EndIf
      t←⊂'Version',v s' ',⍕fmtVersion t
      q←WIN/'"'
     
      :If 0<⍴list←v~keeplast/last←⌈/v
      :AndIf ok←1=msgBox('Forget Versions of ',name)(('Confirm deletion of ',(⍕⍴v),' version',v s':')'',t)'Warn'
          :For t :In list
              f←q,folder,FS,name,(dotVer t),SALTEXT,q
              cmd←(⎕IO+WIN)⊃'rm ' 'erase '
              ⎕SH cmd,f
          :EndFor
          ⎕←(⍕⍴list),' version',list s' deleted.'
      :EndIf
      :If ok∧keeplast∧last>0
          :If last=next←⌊/version ⋄ ⎕←'No file renamed'
          :Else
              new←q,((~WIN)/folder,FS),name,(dotVer next),SALTEXT,q
              old←q,folder,FS,name,(dotVer last),SALTEXT,q
              cmd←(⎕IO+WIN)⊃'mv ' 'rename '
              ⎕SH cmd,old,' ',new        ⍝ chk this works under Unix
              ⎕←'1 version renamed'
              ⎕←'** Any object of that script in the ws will now have the improper reference to the file'
          :EndIf
      :EndIf
    ∇
    
    ∇ SetDelta(ref name version globalname);prev
      :Access Shared Private
      prev←¯1
      :If 2∊ref.⎕NC'SALT_Data.Version' ⋄ prev←ref.SALT_Data.Version ⋄ :EndIf
      ref.SALT_Data←⎕NS''
      ref.SALT_Data.PreviousVersion←prev
      ref.SALT_Data.SourceFile←name
      ref.SALT_Data.Version←version
      ref.SALT_Data.LastWriteTime←⍕lastWrTime name
      ref.SALT_Data.GlobalName←globalname
    ∇
    
    ∇ r←fmtVersion v
      :Access Shared Private
      r←{(0<⍴,⍵)/'[',(⍕⍵),']'}¨v
    ∇
    
    ∇ r←fmtDate v
      :Access Shared Private
      r←0 19⍴'' ⋄ →0⍴⍨0∊⍴v
      r←v ⋄ →0⍴⍨isChar v ⍝ empty v is char: skip
      r←'I4,2(</>,ZI2),I3,2(<:>,ZI2)'⎕FMT⊃,6↑¨↓v
    ∇
    
    ∇ r←lastWrTime w ⍝ Last Write Time for file
      :Access Shared Private
      r←2⊃'a'Dir w
    ∇
    
    ∇ EditorFix args;file;msgbox;z;r;⍙;t;ns;target;nc;i
      :Access Shared Private
⍝ See whether a Class was Loaded and Suggest Updating the file
     
      :Select 2⊃args
     
      :Case 9998 ⍝ Restore SALT_Data and save source
     
          args ⍙←3⊃args ⍝ ⎕NQ'd by Fix case
          ns←args[4]⍎(5⊃args)
          :If 0=ns.⎕NC'SALT_Data' ⍝ If SALT_Data is gone the class WAS refixed
              ns.SALT_Data←⍙
              Fixed ns ⍙
          :EndIf
     
      :Case 'Fix'
          target←args[4]
          :If 9≠target.⎕NC 5⊃args
          :AndIf (9=target.⎕NC'SALT_Data')∨(⊂'⍝SALTSource="')∊13↑¨t←{0::⍬ ⋄ ⎕SRC ⍵}target ⍝ looks like we edited something IN a class
              args[5]←⊂{(1-(⌽⍵)⍳'.')↑⍵}⍕target ⍝ So "move up"
              args[4]←args[4].##
          :EndIf
     
          :If 3≠(args[4].⎕NC)5⊃args
              :If 9=(args[4].⎕NC)(5⊃args),'.SALT_Data' ⍝ Which has a SALT_Data /// Why parens?
                  ⍙←args[4]⍎(5⊃args),'.SALT_Data'
                  ⎕NQ'⎕SE' 9998(args ⍙)        ⍝ Record info and requeue for later
                  args[4].⎕EX(5⊃args),'.SALT_Data'     ⍝ Delete SALT_Data so we realize it was refixed
              :ElseIf (⍴t)≥i←(13↑¨t←{0::⍬ ⋄ ⎕SRC ⍵[4]⍎5⊃⍵}args)⍳⊂'⍝SALTSource="'
                  ⍙←⎕NS''
                  ⎕←⍙.SourceFile←{(¯1+⍵⍳'"')↑⍵}{(⍵⍳'"')↓⍵}i⊃t
                  ⍙.Version←0
                  ⍙.LastWriteTime←⍕lastWrTime ⍙.SourceFile
                  ⍙.GlobalName←''
                  ⎕NQ'⎕SE' 9998(args ⍙)        ⍝ Record info and requeue for later
              :EndIf
          :EndIf
     
      :Case 'Start'
          SE_Editor←'⎕SE'⎕WG'Editor'
          SE_Editor.⎕WX←1
          SE_Editor.onFix←'⎕SE.SALTUtils.EditorFix'
          '⎕SE'⎕WS'Event' 9998 '⎕SE.SALTUtils.EditorFix'
     
      :Case 'End'
          '⎕SE'⎕WS'Event' 9998 0
          ⎕EX'SE_Editor'
     
      :EndSelect
    ∇
    
    WIN←(,'W')≡3⊃'.'⎕wg 'aplversion'
    FS←'/\'[1+WIN]
    LINDEL←(~WIN)↓13 10 ⍝ we shouldn't have to do this
    
    ∇ Fixed(ns ⍙);name;source;z;t;r;last;new;upd;version;sourcefile;n;here;∆
      :Access Shared Private
⍝ Called after class has been fixed to update the source file
     
      source←⎕SRC ns
      name←⍕ns
      :If last←∨/t←{'⍝○⎕∪'≡¯4↑⍵}¨source ⍝ overwrite last version?
          source[t/⍳⍴t]↓⍨←¯4            ⍝ remove marker
          ∆←ns.SALT_Data                ⍝ preserve SALT data
          here←⎕CS(-1+⊥⍨'.'≠t)↓t←⍕ns    ⍝ refix in source ns
          ns←⎕FIX source                ⍝ refix object
          ⎕CS here                      ⍝ come back here
          ns.SALT_Data←∆                ⍝ restore SALT data
      :EndIf
      z←,⊂''
      :Trap 22 ⍝ the file may be gone
          z←fixTabs ⎕SE.UnicodeFile.ReadNestedText ⍙.SourceFile
      :EndTrap
      :If ('<APLScript>'startsWith⍨1⊃z)∧':Class PageClass'startsWith⍨1⊃source
          source←z MakeAPLScript source
      :EndIf
     
      :If source≢z ⍝ Any changes?
      :AndIf (rlb¨source)≢rlb¨z ⍝ we shouldn't have to do this
⍝ There are 2 cases:
⍝ 1. we are adding a new version: we use the next available number
⍝ 2. we are replacing an existing file: we confirm
          sourcefile←⍙.SourceFile
          :If new←last<0<version←⍙.Version ⍝ #1
⍝ There should be a version # but just in case...
              n←2⌊'.'+.={(-⊥⍨FS≠⍵)↑⍵}sourcefile
              t←(-n⍳⍨+\'.'=⌽t)↓t←sourcefile
              t←t,'.',⍕version←1+⌈/0,↑ListVersions/FS splitLast t
              sourcefile←t,SALTEXT
          :EndIf ⍝ #2
          upd←('Update' 'Create'⊃⍨1+new),' source file'
          :If 1=msgBox('You have modified ',⍕name)(upd''sourcefile)'Query'
              :If ~new ⍝ ensure file hasn't been updated outside
              :AndIf ⍙.LastWriteTime≢t←⍕lastWrTime ⍙.SourceFile ⍝ Not same as we loaded?
                  t←⍙.SourceFile''('Was dated ',⍙.LastWriteTime,' when loaded...')('Now dated ',t)'Overwrite changed file?'
                  :If 1≠msgBox'Source file timestamp has changed...'t'Warn' ⋄ →0 ⋄ :EndIf
              :EndIf
     
              source←('⍝:Pragma Line 1'startsWith⍨1⊃source)↓source
              ⎕SE.UnicodeFile.Write sourcefile source''LINDEL
              ⍙.LastWriteTime←⍕lastWrTime ⍙.SourceFile←sourcefile ⍝ Update Timestamp
              ⍙.Version←version
          :EndIf
      :EndIf
    ∇
    
    ∇ r←file MakeAPLScript class;html;i;script;m
⍝ Merge PageClass source with apls file contents
     
      html←(i←(12↑¨file)⍳⊂'</APLScript>')↓file ⍝ Extract the non-APLScript part
      script←1↓(i-1)↑file
      script←({'<'=⍬⍴1↑⍵~' '}¨script)/script ⍝ statements beginning with <
      :If (⍴class)≥i←class⍳⊂'⍝--- APLS Code Begins ---'
          class←¯2↓i↓class
          m←class∧.=¨' '
          class←(+/∧\m)↓(-+/∧\⌽m)↓class
      :EndIf
     
      r←(⊂'<APLScript>'),script,class,(⊂'</APLScript>'),html
    ∇
    
    ∇ {next}←Backup file;p;ext;folder;name;f;d;files;names;v;tgt;n
      :Access Shared Private
⍝ Make a backup copy of a file by copying to next sequence number
      f←Dir file←fixFsep file
      ⎕SIGNAL(1⍴⍴f)↓22       ⍝ ensure the file exists and is unique
     
      folder name←FS splitLast file
      name ext←'.'splitLast name
      n←-1+⊥⍨name≠'.'
      n×←∧/(1↓n↑name)∊⎕D     ⍝ any version #?
      name←n↓name            ⍝ drop version number from file
      v←folder ListVersions name
      next←1+⌈/0,v           ⍝ next version no
      tgt←folder,FS,name,'.',(⍕next),'.',ext
     
      :Trap 0
          {}⎕CMD'copy /y "',file,'" "',tgt,'"'
          ⎕←'Backup made: ',tgt
      :Else
          ⎕←'Unable to backup to ',tgt
      :EndTrap
    ∇
    
    SALTEXT←'.dyalog'
    
    ∇ name←remExt name;n
      n←-⍴SALTEXT ⋄ name↓⍨←n×SALTEXT≡n↑name
    ∇
    
    ∇ name←addExt name;n;x
      n←-⍴x←SALTEXT ⋄ name,←(x≢n↑name)/x
    ∇
    
    ∇ r←folder ListVersions name;d;files;names;se
      :Access Shared Private
⍝ Return version numbers
      se←-⍴SALTEXT
⍝ name←(se×ext≡se↑name)↓name ⍝ remove extension if present
      folder←folder,(FS=¯1↑folder)↓FS
      r←⍬
      :If 0<⍴files←Dir folder,name,'*',SALTEXT
⍝ There is a possibility that Dir reported too many names:
      :AndIf 0<⍴files←((name,'.')∘≡¨(1+⍴name)↑¨files)/files
          names←se↓¨files
          r←{↑2⊃⎕VFI 2⊃'.'splitLast ⍵}¨names
      :EndIf
    ∇
    
    ∇ folder←root ClassFolder folder;special;and;rooted;rs;stem;nocl;rp
⍝ Produce full path by merging root and folder name
      :Access Shared Private
⍝ [xxx] in folder names resolved using System.Environment.(GetFolderPath SpecialFolder.ProgramFiles). [Dyalog] Special-cased
      folder↓⍨←-FS=¯1↑folder                  ⍝ remove last \
      →((rp≢FS,'*')∧∨/(FS,':')=rp←2↑folder)⍴0 ⍝ is it already formatted properly?
      and←{((-FS=¯1↑⍺)↓⍺),(0<⍴⍵)/FS,(FS=1↑⍵)↓⍵}
      special←''
     
⍝ Special names treated here
      :If '['=1↑root
          special←getEnvir'[]'~⍨(rp←root⍳']')↑root
          ('Folder cannot be resolved: ',root)⎕SIGNAL 22⍴⍨0∊⍴special
          folder←special and(rp↓root)and folder
      :Else
          folder←root and folder
      :EndIf
    ∇
    
    ∇ parms←{patn}∆parse arg;d;e;dlm;i;p;pat;q;s;sp;sw;swit;t;D;Er;m;Up;fs;UP;⎕IO;∆
      :Access Shared Private
⍝ PARSE switches and reset argument. Version S2.34
⍝ Special version for SALT: the switches' must be preceded by space
⍝ Spaces are used to delimit arguments. 1st char of 'patn' delimits switches.
⍝ Quotes must be used to include spaces or  FS  in arguments.
⍝ Switches can exist with or without [possibly defaulted] value
⍝ or be elided. Switches not mentioned are refused.
⍝ Shorter names are accepted but '=' MUST be used to supply values.
⍝ Variables holding switch values have the same name as the switch uppercased
⍝ with a ⍙ before.
⍝ Example:
⍝ cmdarg← '/sa /ab= /sc[=] /cd=1 2 3 /e[=]d e f /=*' ∆parse cmdarg
      Er←710 ⍝ this error no can be changed
      dlm←1↑patn,FS ⋄ arg←' ',arg ⋄ ⎕IO←1
      ∆←'⍙' ⍝ this default prefix can be changed
      ∆←(⎕IO⊃⎕NSI),'.',∆
      s←-fs←1 ⍝ force 1 space before switch delimiter
      t←≠\arg='''' ⋄ s←∨\sw←s⌽t<arg⍷⍨(fs⍴' '),dlm ⍝ QUOTED ⋄ all SWITCHES
      'unbalanced quotes'⎕SIGNAL(¯1↑t)⍴Er
      sp←(1↓p)-¯1↓p←p/⍳⍴p←(s/sw),1 ⋄ parms←(~s)/arg ⋄ swit←s/arg ⋄ q←dlm,'='
      Up←⎕AV ⋄ Up[(⍳26)-1-Up⍳'a']←Up[(⍳26)-1-Up⍳'A'] ⋄ i←⎕FX 2 11⍴'r←UP s     r←Up[⎕av⍳s]'
      i←⎕FX(2,i)⍴((i←⍴t)↑'r←d s'),t←'r←UP(~∨\s∊'' [∊='')/s' ⋄ D←¯1↑⎕AV~parms
⍝
⍝ Check for special switch /= which specifies the arguments' delimiter
      →(∨/i←i∨t←¯2↓0 0,i←q⍷patn)↓l0 ⋄ D←t/patn ⋄ patn[p/⍳⍴p←t∨≠\i]←' '
⍝ Check switches: set all allowable switches to 0 (assume not present)
     l0:pat←(+/∧\patn∊' ',dlm)↓patn←UP patn
     l1:→(0∊⍴pat)/l2 ⋄ i←pat⍳dlm ⋄ s←(i-1)↑pat ⋄ ⍎∆,(d s),'←0' ⋄ →l1,⍴pat←i↓pat
⍝
⍝ Process each switch separatly according to their position
     l2:→(0∊⍴swit)/l5 ⋄ i←1↑sp ⋄ s←i↑swit ⋄ swit←i↓swit
      pat←1⌽'>unknown or ambiguous switch: <',1↓t←d s ⋄ q←1≠+/i←t⍷patn
      pat ⎕SIGNAL q⍴Er+1
      pat←1↓(∨\i)/patn ⋄ q←d pat←(¯1+pat⍳dlm)↑pat ⋄ sp←1↓sp
⍝ 'pat' is 1 switch group complete with assignment & value if present
      e←'∊'∊2↑(⍴q)↓pat ⋄ →e↓cm ⋄ pat[pat⍳'∊']←'='
     cm:t←1 ⋄ s←1↓s ⋄ →(∨/p←¯2⌽'[=]'⍷pat)↓mem ⋄ →('='∊s)↓l3,chk
     mem:→(∨/p←pat∊'=')/comp ⋄ m←1⌽'>no value allowed for switch <',q
      m ⎕SIGNAL('='∊s)⍴Er+2 ⋄ →l3
     comp:m←1⌽'>value required for switch <',q
      m ⎕SIGNAL('='∊s)↓Er+3
     chk:t←(i←s⍳'=')↓s ⋄ s[i]←' ' ⋄ →(∧/m←' '=t)/comp
      t←((∧\m)⍱⌽∧\⌽m)/t ⋄ →(' '∧.=pat←(p⍳1)↓pat)/l3
⍝ valid elements are supplied with the pattern: verify them
⍝ If Uppercase is undesirable it should be changed here
      p←(e∧∧/t∊pat)⍱e<∨/(' ',UP t,' ')⍷' ',pat,' '
      m←1⌽'>invalid value for switch <',(i-1)↑s
      m ⎕SIGNAL p⍴Er+4
⍝ Drop trailing spaces, remove surrounding quotes
     l3:→(∨/s←' '=t)↓l4 ⋄ t←(-s⊥s)↓t
     l4:i←∨/s←''''=t ⋄ ⍎∆,q,'←',(i/'1↓(≠\s)/'),'t' ⋄ →l2
⍝
⍝ Find each token in the argument and use the delimiter to separate
⍝ them. The following allows to deal with '' properly:
     l5:s←parms∊' ' ⋄ ∆←≠\q←parms∊'''' ⋄ i←q∧1⌽q ⋄ t←q>¯1⌽q ⍝ t=1ST quote
      p←t∨s>∆ ⍝ DELIMITERS: spaces NOT in quotes OR 1st quote
⍝ COMPRESSOR: any double quote OR last quote NOT in ≠\ or double delim.
      parms[p/⍳⍴p]←1↑D ⋄ parms←((∆<i∨q>1⌽q)⍱p∧1⌽p)/parms
    ∇
    
    ∇ r←r ∆default value
⍝ Default CHARACTER STRING r BY value IF IT ≡0
      :Access Shared Private
      →(r≡1)⍴0 ⍝ also a valid value
      →(r≡0)↓mod ⋄ r←value ⋄ →0
     mod: ⍝ r IS not SCALAR 0 - ⍎ IF value IS NUMERIC
      →(' '=1↑0⍴value)/0 ⋄ r←2⊃⎕VFI r
    ∇
    
⍝ --- Utilities
    
⍝ String Index with minimal length: 2='aa' 'bb' f ⊂,'b'
    strIndex←{∨/b←⍺∊⍵:b⍳1 ⋄ (1=+/b)×1⍳⍨b←((⍴s)↑¨⍺)∊⊂s←,1⊃,⍵}
    
    ∇ r←rlb w;⎕IO
      :Access Shared Private
      ⎕IO←0 ⋄ r←(0⍳⍨w=' ')↓w
    ∇
    
    ∇ r←isChar obj
      :Access Shared Private
      r←0 2∊⍨10|⎕DR,obj
    ∇
    
    ∇ s←lCase s;b;⎕IO;i
      :Access Shared Private
      →(∨/b←(1↓⍴LU)>i←LU[1;]⍳s)↓⎕IO←0
      (b/s)←LU[0;b/i]
    ∇
    
    ∇ r←msgBox(Caption Text Mode);parms;msgbox
⍝ Return 1, 2 or 3 for buttons pressed
      :Access Shared Private
      'msgbox'⎕WC'msgBox'Caption Text Mode('Event' 'All' 1)
      r←4|'MsgBtn1' 'MsgBtn2' 'MsgBtn3'⍳(r←⎕DQ'msgbox')[2]
    ∇
    
    ∇ r←str splitOn1st chars;p;⎕IO
⍝ Split on 1st occurrence of any chars in str
      :Access Shared Private
      ⎕IO←0 ⋄ p←⌊/str⍳chars ⋄ r←(p↑str)((1+p)↓str)
    ∇
    
    ∇ yes←string startsWith subs
      :Access Shared Private
      yes←subs≡(⍴subs)↑string
    ∇
    
    ∇ strs←str splitOn char;⎕ML
      :Access Shared Private
      ⎕ML←1
      strs←1↓¨(strs∊char)⊂strs←(char∊⊃str)↓char,str
    ∇
    
    ∇ r←a splitLast w;p ⍝ Split on last occurrence of a in w
      :Access Shared Private
      p←-(⌽,w)⍳a ⋄ r←(p↓w)((1+p)↑w)
    ∇
    
    ∇ r←isHelp string
      :Access Shared Private
      r←(string~' ')≡,'?'
    ∇
    
    ∇ r←num w
      :Access Shared Private
      r←2∘⊃∘⎕VFI⍣(isChar w)+w
    ∇
    
    ∇ r←condEncl arg ⍝ conditional enclose
      :Access Shared Private
      r←⊂⍣(326≠⎕DR,arg)+arg
    ∇
    
    ∇ (dir path files)←name locateIn folders;dir;nfs;path;files;t;empty
⍝ Find the 1st occurence of file in list of folders
⍝ Return the folder it was found in the list provided. the full path and the files found
      :Access Shared Private
      empty←' '∧.=name ⍝ this wil force return on the first dir in the list
      :For dir :In folders
          :If empty∨0<⍴↑files←'a'Dir path←dir ClassFolder name
              :If ∨/'?*'∊2⊃t←FS splitLast path ⋄ path←1⊃t ⋄ :EndIf
              →0
          :EndIf
      :EndFor
      dir path files←'' '',⊂,¨4⍴0 ⍝ default not found
    ∇
    
    ∇ _nam Default _val
      :Access Shared Private
      ⍎(0=⎕NC _nam)/_nam,'←_val'
    ∇
    
    ∇ {ok}←val setPfkey n;s
      :Access Shared Private
      :If ok←0<⍴s←⍕n
      :AndIf ok←0 36≠.≤s←↑num s
          {}val ⎕PFKEY s
      :EndIf
    ∇
    
    ∇ r←fixTabs source
⍝ Change Tabs into N spaces
      r←⎕AV[10]{~∨/b←⍺=l←⍵:l ⋄ b←⍺=l←(1+3×b)/l ⋄ (b/l)←' ' ⋄ l}¨source
    ∇
    
⍝                        Directory functions
    
    ∇ r←isDir w
      :Access Shared Private
      r←1∊↑'a'Dir w
    ∇
    
    ∇ r←isFile w
      :Access Shared Private
      r←0∊↑'a'Dir w ⍝ assume max 1 result only
    ∇
    
    ∇ s←fixFsep w;i
      :Access Shared Private
      i←i/⍳⍴i←'/\'∊⍨s←w ⋄ s[i]←FS ⍝ fix Folder separator
    ∇
    
    ∇ files←{parms}Dir x;switches;dfa
⍝ List directory using DOS DIR command
⍝ parms may be
⍝ dD: list dirs only
⍝ fF: list files only
⍝ aA: list all data (timestamp, size, name)
      :Access Shared Private
      'parms'Default''
      files←WIN NtDirX{⍺:⍺⍺ ⍵ ⋄ ⍵⍵ ⍵}DirU x
      :If ∨/2↑dfa←∨/3 2⍴'dDfFaA'∊parms
          files←((↑files)=↑dfa)∘⌿¨files
      :EndIf
      :If 0=3⊃dfa ⋄ files←4⊃files ⋄ :EndIf
    ∇
    
    ∇ files←DirU x;list;cut;b;dir;⎕IO;⎕ML
⍝ Unix ls: drop 1st line?, cut into sections
      ⎕IO ⎕ML←1 0
      files←0⍴¨0 '' 0 ''
      :Trap 11          ⍝ drop .
          →0⍴⍨0∊⍴list←' ',↑{('total'≡5⍴↑⍵)↓⍵}⎕SH'ls -ld ',x,' 2>/dev/null'
      :Else ⋄ →0
      :EndTrap
      b←cut⍲1⌽cut←∧⌿' '=↑list
      dir←list[;2]='d'
      files←1⊃⌽list←0 1∘↓¨⊃⊂/b∘/¨cut list
      files←{(-⊥⍨' '=⍵)↓⍵}¨↓(⌽∧\FS≠⌽1⌷[1]files⍪' ')/files
⍝ 1st section should be permissions, last is name
      files←dir(↓⍕5↓¯1↓list)(2⊃⎕VFI,' ',5⊃list),⊂files
    ∇
    
    ∇ rslt←{att}NtDirX path;handle;next;ok;attrs;⎕IO;FindFirstFileA;FindNextFileA;FindClose;FileTimeToLocalFileTime;FileTimeToSystemTime;GetLastError;max;keep;mask
⍝ Return NT directory information
      :Access Shared Private
      ⎕IO←0 ⋄ rslt←4⍴⊂'' ⋄ max←2*32
      keep←24 26 27 ⍝ normal files (or archived) and folders
      :If 0≠⎕NC'att' ⋄ keep,←('HS'∊att)/30 29 ⋄ :EndIf
      mask←(⍳32)∊keep
      FindDefine
      handle next←FindFirstFile path
      →handle↓0 ⍝ file not found
      rslt←,⊂next
      :While 1=0⊃ok next←FindNextFile handle ⋄ rslt,←⊂next ⋄ :EndWhile
      :If 0 18∨.≠ok next ⋄ ('ntdir error:',⍕next)⎕SIGNAL 11 ⋄ :EndIf
      ok←FindClose handle
      rslt←↓[0]1 0 0 1 1 0 1 0/⊃rslt       ⍝ bin the unwanted elements
      (0⊃rslt)←(attrs←(32⍴2)⊤0⊃rslt)[27;]  ⍝ Get attributes into bits
      rslt←(mask∧.≥attrs)∘/¨rslt           ⍝ discard hidden/system unless wanted
      rslt[1]←Filetime_to_TS¨¨rslt[1]      ⍝ put times into ⎕ts format
      (2⊃rslt)←max⊥max|⍉⊃2⊃rslt            ⍝ combine size elements
      rslt←(~(3⊃rslt)∊1 2⍴¨'.')∘⌿¨rslt     ⍝ remove . & ..
    ∇
    
    ∇ rslt←Filetime_to_TS filetime;⎕IO
      :Access Shared Private
      :If 1≠0⊃rslt←FileTimeToLocalFileTime filetime(⎕IO←0)
      :OrIf 1≠0⊃rslt←FileTimeToSystemTime(1⊃rslt)0
          rslt←0 0                   ⍝ if either call failed then zero the time elements
      :EndIf
      rslt←1 1 0 1 1 1 1 1/1⊃rslt    ⍝ remove day of week
    ∇
    
    ∇ FindDefine;WIN32_FIND_DATA;v111;T
      :Access Shared Private
      v111←'11.1.'≡5↑1⊃'.'⎕WG'aplversion'
      T←'A*'[v111]
      WIN32_FIND_DATA←'{I4 {I4 I4} {I4 I4} {I4 I4} {U4 U4} {I4 I4} T[260] T[14]}'
      'FindFirstFileA'⎕NA'I4 kernel32.C32|FindFirstFile',T,' <0T >',WIN32_FIND_DATA
      'FindNextFileA'⎕NA'U4 kernel32.C32|FindNextFile',T,' I4 >',WIN32_FIND_DATA
      ⎕NA'kernel32.C32|FindClose I4'
      ⎕NA'I4 kernel32.C32|FileTimeToLocalFileTime <{I4 I4} >{I4 I4}'
      ⎕NA'I4 kernel32.C32|FileTimeToSystemTime <{I4 I4} >{I2 I2 I2 I2 I2 I2 I2 I2}'
      ⎕NA'I4 kernel32.C32∣GetLastError'
    ∇
    
    ∇ rslt←FindFirstFile name;⎕IO
      :Access Shared Private
      rslt←FindFirstFileA name(⎕IO←0)
      :If ¯1=0⊃rslt                   ⍝ INVALID_HANDLE_VALUE
          rslt←0 GetLastError
      :Else
          (1 6⊃rslt)trimAt←↑⎕AV   ⍝ shorten the file name at the null delimiter
          (1 7⊃rslt)trimAt←↑⎕AV   ⍝ and for the alternate name
      :EndIf
    ∇
    
    ∇ rslt←FindNextFile handle;⎕IO
      :Access Shared Private
      rslt←FindNextFileA handle(⎕IO←0)
      :If 1≠0⊃rslt
          rslt←0 GetLastError
      :Else
          (1 6⊃rslt)trimAt←↑⎕AV   ⍝ shorten the filename
          (1 7⊃rslt)trimAt←↑⎕AV   ⍝ shorten the alternate name
      :EndIf
    ∇
    
    ∇ name←name trimAt char;⎕IO
⍝ Truncates a character vector at the char delimiting byte.
      :Access Shared Private
      ⎕IO←0 ⋄ name↑⍨←name⍳char
    ∇
    
⍝                       Registry functions
    
    ∇ r←getEnvir w
      :Access Shared Private
      r←2 ⎕NQ'.' 'GetEnvironment'w
    ∇
    
    ∇ value←regSetting arg;name;canbeempty;v
⍝ Return setting from the registry/environment
⍝ arg is: Key, default is not present or if empty, and can be empty
      arg←,condEncl arg
      (name value canbeempty)←arg,(⍴arg)↓'' '' 1
      :Access Shared Private
      :Trap 0
          :If canbeempty∨0<⍴v←getEnvir'SALT\',name ⋄ value←v ⋄ :EndIf
      :EndTrap
    ∇
    
    ∇ name saveSettings value;key
⍝ Save name with value in registry
      :Access Shared Private
      key←↑SettingsTable[SettingsTable[;1]⍳⊂name;3]
      regPutString key value
    ∇
    
⍝ The following functions were modified from
⍝ APL Team Ltd ⋄ http://www.aplteam.de ⋄ mailto:kai@aplteam.com
    
    ∇ regClose HANDLE;RegCloseKey;sink
      :Access Shared Private
      ⎕NA'U ADVAPI32.dll.C32|RegCloseKey U'
      sink←RegCloseKey HANDLE
    ∇
    
    ∇ HANDLE←regGetHandle KEY;HKEY;RegCreateKeyExA;KEY_ALL_ACCESS;T
      :Access Shared Private
      HKEY←2147483649             ⍝ 'HKEY_CURRENT_USER' HEX 0x80000001
      KEY_ALL_ACCESS←983103       ⍝ HEX 0xF003F
    ⍝ The next line covers the case for V11.0, V11.1 reg & Unicode
      T←'A*'[⎕IO+'11.1.'≡5↑2⊃'.'⎕WG'aplversion']
      'RegCreateKeyExA'⎕NA'I ADVAPI32.dll.C32|RegCreateKeyEx',T,' U <0T I <0T I I I >U >U'
      HANDLE←⊃2⊃RegCreateKeyExA HKEY KEY 0 '' 0 KEY_ALL_ACCESS 0 0 0
    ∇
    
    ∇ regPutString(SUBKEY STRING);SUBKEY;STRING;RegSetValueExA;REG_SZ;Path;HANDLE;ver;T
⍝ Stores the value of a Registry SUBKEY
      :Access Shared Private
      ver←{(2>+\'.'=⍵)/⍵}2⊃'#'⎕WG'aplversion'
      Path←'Software\Dyalog\Dyalog APL/W ',ver,'\SALT'
      HANDLE←regGetHandle Path
      STRING←,STRING
      REG_SZ←1 ⍝ String data type
      T←'A*'[⎕IO+'11.1.'≡5↑2⊃'.'⎕WG'aplversion']
      'RegSetValueExA'⎕NA'I ADVAPI32.dll.C32|RegSetValueEx',T,' U <0T I I <0T I4'
      STRING←RegSetValueExA HANDLE SUBKEY 0 REG_SZ STRING(1+⊃⍴STRING)
      regClose HANDLE
    ∇
    
:EndNameSpace ⍝ SALTUtils