﻿:Class Summary
    
    ⎕ml←3 ⋄ ⎕io←1
    
    ∇ r←List
      :Access Shared Public
      r←⎕NS¨3⍴⊂''
      r.(Group Parse)←⊂'Workspace' ''
      r.Name←'Summary' 'Calls' 'Xref'
      r[1].Desc←'Returns a summary of the objects in a scriptfile'
      r[2].Desc←'Returns the calling tree of a function in a scriptfile'
      r[3].Desc←'Returns Cross-reference of the objects in a scriptfile'
    ∇
    
    ∇ r←Run(Cmd Args);ct;ns;sw;sp;file;arg;tmpNS
      :Access Shared Public
      sp←1⍳⍨(' '=Args)∧maskdq Args
      file arg←(sp↑Args)(sp↓Args)
      tmpNS←⎕SE.SALT.Load file,' -noname'
      ct←⎕SE.SALT.New'Utils\CallingTree'tmpNS
      :Select Cmd
      :Case 'Calls' ⋄ r←ct.Calls arg
      :Case 'Xref' ⋄ r←ct.Xref
      :Case 'Summary' ⋄ r←format ct.FnRefs
      :EndSelect
    ∇
    
    ∇ r←maskdq text
      r←=\''''≠text
    ∇
⍝ Produce a summary of a class' (in a .Dyalog file) objects.
⍝ For a given class all regular fns & dfns are reported,
⍝ listing their syntax and scope.
⍝ Syntax is [nr][012][mdf] where
⍝ n is no result, r is result
⍝ 0 is niladic, 1 monadic and 2 dyadic,
⍝ m is a Monadic operator, d a Dyadic op and F a Function
⍝ Ex: r0f is a result returning niladic fn
⍝ Scope is [SPCD] where
⍝ S is shared, P is public, C is constructor and D is destructor
    
    ∇ r←format m3c;ss;t3
    ⍝ Format function references
    ⍝ 3rd column contains scope, size & syntax as per ⎕AT
      t3←⊃,0 1↓ss←0 1↓⊃m3c[;3] ⋄ ss[;2]←t3[;1] ⋄ t3←↓1+|0 1↓t3
      t3←t3⌷¨⊂⊃∘.,/'nr' '012' 'fmd'
      r←⍕'name' 'scope' 'size' 'syntax'⍪m3c[;1],ss,t3
    ∇
    
    ∇ r←Help Cmd
      :Access Shared Public
      r←''
      r,←⊂'Arg: namespace.function; Produces the calling tree of a fn in a class'
      r,←⊂'Arg: namespace; Produces a cross-reference of all objects in a class'
      r,←⊂'Arg: namespace; Produces a detailed description of functions in a class'
      r←r⊃⍨'Calls' 'Xref' 'Summary'⍳⊂Cmd
    ∇
    
    
    
:EndClass